56	Backup script for your Web and MySQL db servers!	backup-script-for-your-web-and-mysql-db-servers		<p>Assalam-u-alaikum,</p>\
<p>This is another of the much asked material. The backup script. Below are two scripts. One for backing up the web site content and the other to backup your MySQL Databases.</p>\
<p>Both scripts will push the backed up content to a FTP server for added availability. The scripts are pretty straight forward to use. You just need to adjust a few variables and rest is taken care of.</p>\
<p>For these scripts to work, you will need to setup the following layout:</p>\
<p>/backups</p>\
<p>/backups/localdbs  # (this will contain the daily Database backups)</p>\
<p>/backups/localsites # (this will contain the daily website content backups)</p>\
<p> </p>\
<p>Each day, a directory of the format YYYYMMDD will be created in localdbs and localsites directories. Which, will in-turn contain the actual DB dump files (compressed) or the website content (tar.bz2) .</p>\
<p><strong>Update</strong>: The scripts are updated to automatically delete backups, older than 14 days (or whatever you configure), from both local systems and remote FTP location.</p>\
<p> </p>\
<p> </p>\
<p>First the backup script to backup websites contents:-</p>\
<p><strong><span style="text-decoration: underline;">sitesbackup.sh file on www.yourdomain.com:-</span></strong><br /><br /><span style="font-family: courier new,courier;">#!/bin/sh<br />###########################################################################################<br /># Filename:     sitesbackup.sh<br /># Purpose:      Backup web content hosted on this server.<br /># Author:       Muhammad Kamran Azeem (kamran _at_ wbitt _dot_ com)<br /># Created:      20080628<br /># Modified:     20080720, 20080628<br /># Note:         For FTP, make sure that the file ~/.netrc exists in the home directory<br />#               of the user running this script. The permissions must be 0600.<br />#               The syntax of .netrc file is:<br />#               machine ftpserver.somedomain.com<br />#               login ftpusername<br />#               password somepassword<br />#<br /># Note2:        This script must have permissions not more than 0750 . Because<br />#               this script contains username and password of your mysql admin user.<br />#<br /># Note 3:       You will need to frequently delete the old backups both from local disk,<br />#               as well as from the FTP server.<br />#<br /># Note 4:       Setup a cronjob as:-<br />#               0 2 * * * /backups/sitesbackup.sh<br />#<br />############################################################################################<br /></span></p>\
<p><span style="font-family: courier new,courier;">######### User configuration. Start. ############################################# </span></p>\
<p><span style="font-family: courier new,courier;">FTPSERVER=</span><span style="font-family: courier new,courier;">ftpserver.somedomain.com</span><br /><span style="font-family: courier new,courier;"><br /># Backup Dest directory, change this if you have some other location<br />BACKUPDIR="/backups/localsites"<br />WEBCONTENTDIR="/var/www/vhosts"<br /><br /># FTP client program to be used. LFTP is the best client. You will come to  know yourself!:<br />FTP=lftp<br /></span></p>\
<p><span style="font-family: courier new,courier;"><br /># This is the time period for which the backups will be retained.<br /># Backups before this date will be deleted! Make selection carefully.<br /># The value is number of days before $TODAY.<br />RETENTIONPERIOD=14</span></p>\
<p><span style="font-family: courier new,courier;"># Store list of sites<br />SITESLIST=""<br /><br /># DO NOT BACKUP these sites / directories<br /># (these will be names of actual directory and file names you wish to skip)<br />IGNORESITES="test.com"<br /></span></p>\
<p><span style="font-family: courier new,courier;"><br /></span><span style="font-family: courier new,courier;">########## User configuration. End. ###############################################<br /></span></p>\
<p><span style="font-family: courier new,courier;"># Paths to various utilities / programs ...<br /></span><span style="font-family: courier new,courier;">TODAY=$(date +%Y%m%d)</span></p>\
<p><span style="font-family: courier new,courier;">TAR="$(which tar)"<br />RSYNC="$(which rsync)"<br />CHOWN="$(which chown)"<br />CHMOD="$(which chmod)"<br />GZIP="$(which gzip)"<br />BZIP2="$(which bzip2)"<br /><br /># Main directory where today's backups will be stored<br />TODAYBACKUPDIR="$TODAY"<br />REMOVELASTBACKUPDATE=$(date --date="$RETENTIONPERIOD days ago" +%Y%m%d)</span></p>\
<p><span style="font-family: courier new,courier;"><br /># Get hostname<br />HOST="$(hostname)"<br /><br />echo "Here is the configuration, you specified:-"<br />echo "FTPSERVER=$FTPSERVER"<br /><br />echo "WEBCONTENTDIR=$WEBCONTENTDIR"<br />echo "BACKUPDIR=$BACKUPDIR"<br />echo "TODAYBACKUPDIR=$TODAYBACKUPDIR"<br />echo "RETENTIONPERIOD=$RETENTIONPERIOD"<br />echo "REMOVELASTBACKUPDATE=$REMOVELASTBACKUPDATE"</span></p>\
<p><span style="font-family: courier new,courier;">echo "System Hostname was found automatically as: $HOST"<br /><br />echo "Starting WebContent backup...."<br />[ ! -d $BACKUPDIR/$TODAYBACKUPDIR ] && mkdir -p $BACKUPDIR/$TODAYBACKUPDIR || :<br /><br /># Get all websites list first<br />SITESLIST="$(ls $WEBCONTENTDIR)"<br /><br />for SITE in $SITESLIST<br />do<br /> skipsite=-1<br /> if [ "$IGNORESITES" != "" ];<br /> then<br /> for i in $IGNORESITES<br /> do<br /> [ "$SITE" == "$i" ] && skipsite=1 || :<br /> done<br /> fi<br /><br /> if [ "$skipsite" == "-1" ] ; then<br /> FILE="$BACKUPDIR/$TODAYBACKUPDIR/$SITE.$HOST.$TODAY.tar.bz2"<br /> echo "Backing up site $SITE..... Creating $FILE..."<br /> $TAR   cjf   $FILE    $WEBCONTENTDIR/$SITE<br /> fi<br />done<br /><br />echo "WebContent Backtup complete. Now starting FTP upload..."<br /><br />cd $BACKUPDIR/$TODAYBACKUPDIR/<br /><br /># Create a directory on ftp server with today's date. And upload the file to it.</span></p>\
<p><span style="font-family: courier new,courier;">$FTP $FTPSERVER << EOF<br />mkdir $TODAY<br />cd $TODAY<br />mput *.tar.bz2<br />ls -aL<br />EOF<br /><br />cd -<br /><br />echo "FTP Upload complete."<br /></span></p>\
<p>echo "Time to remove old backups from local system  and remote FTP server."<br />echo "First remove the directory $BACKUPDIR/$REMOVELASTBACKUPDATE from local system..."<br />echo "NOTE: Make sure you don't have any typing mistake in the next lines below,"<br />echo "as IT HAS POTENTIAL TO WIPE OFF YOUR SERVER HARD DISK CLEAN !!!"<br />echo "YOU HAVE BEEN WARNED."<br />echo "Un-comment the rm -fr lines below when you are SURE.".<br /><br /><br />cd $BACKUPDIR<br /># rm -fr $REMOVELASTBACKUPDATE<br /><br />echo "Deleting $REMOVELASTBACKUPDATE from $FTPSERVER..."<br />$FTP $FTPSERVER << EOF<br /># rm -fr  $REMOVELASTBACKUPDATE<br />ls -aL<br />EOF<br /><br />cd -</p>\
<p><span style="font-family: courier new,courier;">exit 0</span><br /><br /></p>\
<p>Now the backup script for MySQL database server:-</p>\
<p><strong><span style="text-decoration: underline;"> dbbackup.sh file on www.yourdomain.com:-</span></strong><br /><br /><span style="font-family: courier new,courier;">#!/bin/sh<br />###########################################################################################<br /># Filename:    dbbackup.sh<br /># Purpose:    Backup MySQL databases hosted on this server.<br /># Author:       Muhammad Kamran Azeem (kamran _at_ wbitt _at_ com)<br /># Created:      20080424<br /># Modified:     20080720, 20080628<br /># Note:         For FTP, make sure that the file ~/.netrc exists in the home directory<br />#               of the user running this script. The permissions must be 0600.<br />#               The syntax of .netrc file is:<br />#               machine ftpserver.somedomain.com<br />#               login ftpusername<br />#               password somepassword<br />#<br /># Note2:        This script must have permissions not more than 0750 . Because<br />#               this script contains username and password of your mysql admin user.<br />#<br /># Note 3:       You will need to frequently delete the old backups both from local disk,<br />#               as well as from the FTP server.<br />#<br /># Note 4:       Setup a cronjob as:-<br />#               0 3 * * * /backups/dbbackup.sh<br />#<br />############################################################################################<br /><br />########## User configuration. Start. ######################################################<br /></span></p>\
<p><span style="font-family: courier new,courier;">FTPSERVER=</span><span style="font-family: courier new,courier;">ftpserver.somedomain.com</span><br /><span style="font-family: courier new,courier;"><br />MYSQLUSER="root"     # MySQL root USERNAME<br />MYSQLPASS="mysqlrootpasswd"       # MySQL root PASSWORD<br />MYSQLHOST="localhost"          # MySQL Hostname<br /><br /># Backup Dest directory, change this if you have someother location<br />BACKUPDIR="/backups/localdbs"<br /><br /># This is the time period for which the backups will be retained.<br /># Backups before this date will be deleted! Make selection carefully.<br /># The value is number of days before $TODAY.<br />RETENTIONPERIOD=14</span></p>\
<p><span style="font-family: courier new,courier;"><br /># Store list of databases<br />DBLIST=""<br /><br /># DO NOT BACKUP these databases<br />IGNOREDBS="test"<br /><br /># FTP client program to be used:<br />FTP=lftp<br /></span></p>\
<p><span style="font-family: courier new,courier;"><br />########## User configuration. End. ###############################################</span></p>\
<p><br /><span style="font-family: courier new,courier;">TODAY=$(date +%Y%m%d)<br /></span></p>\
<p>REMOVELASTBACKUPDATE=$(date --date="$RETENTIONPERIOD days ago" +%Y%m%d)</p>\
<p><span style="font-family: courier new,courier;"># File to store current backup file<br />FILE=""<br /></span></p>\
<p><span style="font-family: courier new,courier;"># Paths to various utlities / programs ...<br />MYSQL="$(which mysql)"<br />MYSQLDUMP="$(which mysqldump)"<br />CHOWN="$(which chown)"<br />CHMOD="$(which chmod)"<br />GZIP="$(which gzip)"<br />BZIP2="$(which bzip2)"<br /><br /># Main directory where today's backups will be stored<br />TODAYBACKUPDIR="$TODAY"<br /><br /># Get hostname<br />HOST="$(hostname)"<br /><br />echo "Here is the configuration, you specified:-"<br />echo "FTPSERVER=$FTPSERVER"<br />echo "MYSQLUSER=$MYSQLUSER"<br />echo "MYSQLPASS=[Edit this script file to see the password]!"<br />echo "MYSQLHOST=$MYSQLHOST"<br />echo "BACKUPDIR=$BACKUPDIR"<br />echo "TODAYBACKUPDIR=$TODAYBACKUPDIR"</span></p>\
<p><span style="font-family: courier new,courier;">echo "RETENTIONPERIOD=$RETENTIONPERIOD"<br />echo "REMOVELASTBACKUPDATE=$REMOVELASTBACKUPDATE"<br />echo "System Hostname was found automatically as: $HOST"<br /><br />echo "Starting DB backup/dump...."<br />[ ! -d $BACKUPDIR/$TODAYBACKUPDIR ] && mkdir -p $BACKUPDIR/$TODAYBACKUPDIR || :<br /><br /># Get all database list first<br />DBLIST="$($MYSQL -u $MYSQLUSER -h $MYSQLHOST -p$MYSQLPASS -Bse 'show databases')"<br /><br />for DB in $DBLIST<br />do<br /> skipdb=-1<br /> if [ "$IGNOREDBS" != "" ];<br /> then<br /> for i in $IGNOREDBS<br /> do<br /> [ "$DB" == "$i" ] && skipdb=1 || :<br /> done<br /> fi<br /><br /> if [ "$skipdb" == "-1" ] ; then<br /> FILE="$BACKUPDIR/$TODAYBACKUPDIR/$DB.$HOST.$TODAY.dump.bz2"<br /> # do all in one job in pipe,<br /> # connect to mysql using mysqldump for select mysql database<br /> # and pipe it out to gz file in backup dir :)<br /> echo "Processing Database $DB..... Creating $FILE..."<br /> $MYSQLDUMP -u $MYSQLUSER -h $MYSQLHOST -p$MYSQLPASS $DB | $BZIP2 -9 > $FILE<br /> fi<br />done<br /><br />echo "Database Dump complete. Now starting FTP upload..."<br /><br />cd $BACKUPDIR/$TODAYBACKUPDIR/<br /><br /># Create a directory on ftp server with today's date. And upload the backup files to it.<br /></span></p>\
<p><span style="font-family: courier new,courier;">$FTP $FTPSERVER << EOF<br />mkdir $TODAY<br />cd $TODAY<br />mput *.dump.bz2<br />ls -aL<br />EOF<br /><br />cd -<br /><br />echo "FTP Upload complete."<br /></span></p>\
<p>echo "Time to remove old backups from local system  and remote FTP server."<br />echo "First remove the directory $BACKUPDIR/$REMOVELASTBACKUPDATE from local system..."<br />echo "NOTE: Make sure you don't have any typing mistake in the next lines below,"<br />echo "as IT HAS POTENTIAL TO WIPE OFF YOUR SERVER HARD DISK CLEAN !!!"<br />echo "YOU HAVE BEEN WARNED."<br />echo "Un-comment the rm -fr lines below when you are SURE.".<br /><br /><br />cd $BACKUPDIR<br /># rm -fr $REMOVELASTBACKUPDATE<br /><br />echo "Deleting $REMOVELASTBACKUPDATE from $FTPSERVER..."<br />$FTP $FTPSERVER << EOF<br /># rm -fr  $REMOVELASTBACKUPDATE<br />ls -aL<br />EOF<br /><br />cd -</p>\
<p><span style="font-family: courier new,courier;">exit 0</span></p>\
<p>##########################################################</p>\
<p> </p>\
<p>Alhumdulillah. DONE.</p>		1	11	0	34	2008-07-02 07:35:59	64		2010-12-25 18:52:16	74	0	0000-00-00 00:00:00	2008-07-02 07:35:59	0000-00-00 00:00:00			show_title=\
link_titles=\
show_intro=\
show_section=\
link_section=\
show_category=\
link_category=\
show_vote=\
show_author=\
show_create_date=\
show_modify_date=\
show_pdf_icon=\
show_print_icon=\
show_email_icon=\
language=\
keyref=\
readmore=	5	0	68			0	4919	robots=\
author=
